
import Vue from 'vue'
import Modal from './modal.vue'

Modal.show = (config)=> {
    let instance = Vue.extend({
        data() {
            return { show: false }
        },
        render() { return(
            <Modal value={this.show} title={config.title} 
            onInput={(val)=> {
                this.show = val
            }} onOk={()=>{
                config.onOk()
            }} type={config.type} cover={config.cover} maskClosable={config.maskClosable}>
                {config.content || config.render()}
            </Modal>
        )},
        watch: {
            show(val) {
                if(!val) {
                    setTimeout(()=> {
                        document.body.removeChild(this.$el)
                    },300)
                }
            }
        }
    })
    let vmodal = new instance()
    vmodal.$mount()
    vmodal.show = true
    document.body.appendChild(vmodal.$el)
}

export default Modal